

clear all
cd 'C:\Users\Ian\dropbox\personal\mem key\Robust spectrum'

Ns=10000;

% set T for sample length in quarters. 
T=200;

LR_wn=zeros(Ns,1);
LRM_wn=zeros(Ns,1);
tester=[-.99 -.9 -.75 -.5 -.25 0 .25 .5 .75 .9 .99];

LB_wn=zeros(Ns,20);
Q=zeros(1,20);
NW_wn=LB_wn;

for count=1:Ns
    if floor(count/1000)==count/1000; disp(count); end;

    % generate white-noise consumption growth
    x=randn(T,1);

    
    % this gets the maximum likelihood ratio in a way suggested by Andrews
    % and Ploberger (1996) (much easier than actually estimating the full
    % ARMA(1,1))
    % LR_wn is the likelihood ratio with the mean known to be zero. LRM_wn
    % is for when the mean is estimated.
        for i=1:11
            test(i)=AP(x-mean(x),tester(i));
        end

        [~,ind]=min(test);
        piap=fminsearch(@(z) AP(x-mean(x),z),tester(ind),optimset('display','off'));

        LR_wn(count)=T*log(mean(x.^2)/AP(x-mean(x),piap));
        LRM_wn(count)=T*log(mean((x-mean(x)).^2)/AP(x-mean(x),piap));
    
    % get the LB statistic
    aa=xcorr(x-mean(x),'coeff');
    for H=1:20
        cc=aa(T+1:T+H);
        Q(H)=T*(T+2)*sum((cc.^2)./[T-[1:H]']);
    end

    LB_wn(count,:)=Q;
    
end

cv95=prctile(LR_wn,95);
cv99=prctile(LR_wn,99);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% x(t) = theta*x(t-1) + eps(t) - theta*eps(t-1);
theta=.99^.25;
phi=.99021;

% For the HS experiment
% b(L) = (1-theta*L)/(1-phi*L);
% b(beta) = (1-theta*beta)/(1-phi*beta);
% theta=(1-b(beta)*(1-phi*beta))/beta;

% beta=.99^.25;
% bbeta=(1-.99021*beta)/(1-beta*beta);
% 
% theta=.94;
% phi=(1-bbeta*(1-theta*beta))/beta;

% We select theta so that the LRSD from the HS model is the same as in
% ours. Then we ask if you believed HS, what are the odds that you'd reject
% in favor of white noise? By HS here we mean a model with an AR root of
% 0.99. We could also redo this for many different AR roots to see how fast
% the rejection probabilities change. 
% theta=0.99;
% beta=.99^.25;
% phi=(1/beta)*(1-(1-theta*beta)*(1-0.98932*beta)/(1-(.99^.25)*beta));


for theta=[.99^.25 .995 .99 .98 .94]

beta=.99^.25;
phi=(1/beta)*(1-(1-theta*beta)*(1-0.99021*beta)/(1-(.99^.25)*beta));

% (1-beta*phi)/(1-beta*theta)=(1-0.99021*beta)/(1-(.99^.25)*beta);


LR=zeros(Ns,1);
LRM=LR;
LB=zeros(Ns,20);
NW=LB;

sigma=.01465;
sigmaw=.01472;

mu=.0045;
muw=.0037;

for count=1:Ns
%     if floor(count/1000)==count/1000; disp(count); end;
    
    draw=randn(1000+T,1);
   
    x=zeros(999+T,1);
    for i=2:999+T
        x(i)=phi*x(i-1)+draw(i)-theta*draw(i-1);
    end
    x=x+((1-theta)/(1-phi))*(1/sigma)*(mu-muw);
    
    x=x(1000:end);
    
    for i=1:11
        test(i)=AP(x-mean(x),tester(i));
    end
    [~,ind]=min(test);
    piap=fminsearch(@(z) AP(x-mean(x),z),tester(ind));
    
    LR(count)=T*log(mean(x.^2)/AP(x-mean(x),piap));
    LRM(count)=T*log(mean((x-mean(x)).^2)/AP(x-mean(x),piap));

    % get the LB statistic
    aa=xcorr(x-mean(x),'coeff');
    for H=1:20
        cc=aa(T+1:T+H);
        Q(H)=T*(T+2)*sum((cc.^2)./[T-[1:H]']);
    end

%     plot(bb);
    LB(count,:)=Q;
    
%     NW(count,:)=var(x);
%     cc=xcov(x,x,'biased');
% 
%     bottom=[.05:.05:1]*T+1;
%     NW(count,:)=cc'*max( 1-bsxfun(@times,abs([-T+1:T-1]'),1./bottom) ,0);
    
end

disp('**************')
disp('theta=')
disp(theta)
disp('')
[mean(LB(:,5)>prctile(LB_wn(:,5),95))]
% mean(LR>cv95)
mean(LRM>prctile(LRM_wn,95))

disp('**************')


end

